
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8" />

	<script
  src="https://code.jquery.com/jquery-3.6.0.min.js"
  integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4="
  crossorigin="anonymous"></script>

	<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/dt/dt-1.10.25/kt-2.6.2/datatables.min.css"/>
	<script type="text/javascript" src="https://cdn.datatables.net/v/dt/dt-1.10.25/kt-2.6.2/datatables.min.js"></script>
	<script type="text/javascript" src="Editor-2.0.4/js/dataTables.editor.min.js"></script>
	<link rel="stylesheet" type="text/css" href="Editor-2.0.4/css/editor.dataTables.min.css"/>

	<script src="https://cdnjs.cloudflare.com/ajax/libs/selectize.js/0.13.3/js/standalone/selectize.js" integrity="sha512-pF+DNRwavWMukUv/LyzDyDMn8U2uvqYQdJN0Zvilr6DDo/56xPDZdDoyPDYZRSL4aOKO/FGKXTpzDyQJ8je8Qw==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/selectize.js/0.13.3/css/selectize.default.min.css" integrity="sha512-H955AcCOE/fUjX4XWkN0FwjCYVV/zioSF6VpUKCcrGdR1Wa8paFWYixWYp85npbnx3i1kZCH4Rm4TRxut2+d5A==" crossorigin="anonymous" referrerpolicy="no-referrer" />

	<link rel="stylesheet" href="editor.selectize.css" />
	<script type="text/javascript" src="editor.selectize.js"></script>

</head>
<body>
	<table id="table_id" class="display hover" style="width:100%">
		<thead>
			<tr>
				<th></th>
				<th></th>
			</tr>
		</thead>
		<tbody>
		</tbody>
	</table>

	<script type="text/javascript">
		$(document).ready(function() {
			let storage = {
				rows: {
					'row_1': {
						'DT_RowId': 'row_1',
						'field1': [ 'A', 'B', 'C' ],
						'field2': "0"
					},
					'row_2': {
						'DT_RowId': 'row_2',
						'field1': [ 'D' ],
						'field2': "0"
					}
				},
			};

			let editor = new $.fn.dataTable.Editor({
				table: "#table_id",
				fields: [ {
						name: "field1",
						type: 'selectize',
						options: [
							{ 'label': 'A', 'value': 'A' },
							{ 'label': 'B', 'value': 'B' },
							{ 'label': 'C', 'value': 'C' },
							{ 'label': 'D', 'value': 'D' }
						],
						separator: ';',
						opts: { delimiter: ';', },
						attr: { multiple: true, },
					}, {
						name: "field2",
					},
				],
				ajax: function ( method, url, dtedit, success, error ) {
					console.log(dtedit);
					let output = { data: [] };

					const action = dtedit.action;
					const data = dtedit.data;
					switch( action ) {
						case 'edit': {

							// update storage
							for (const [rowId, fields] of Object.entries(data)) {
								output.data.push(storage.rows[rowId]);

								for (const [fieldName, value] of Object.entries(fields)) {
									storage.rows[rowId][fieldName] = [ '', null ].includes(value) ? null : value;
								}
							}

							// callback
							success(output);

							break;
						}
					}

					success(output);
				},
			});

			let table = $('#table_id').DataTable({
				dom: "frtip",
				info: false,
				keys: {
        			editor: editor,
    			},
				lengthChange: false,
				ordering: false,
				paging: false,
				searching: false,
				select: false,
				columns: [
					{ name: 'field1', data: 'field1' },
					{ name: 'field2', data: 'field2' },
				],
			});

			table.on( 'key-focus', function( event, dt, cell, origevent ) {
				editor.inline( cell.node() );
			});

			table.on( 'key-blur', function(event, dt, cell) {
				editor.submit();
			});

			for (const [rowId, row] of Object.entries(storage.rows)) {
				table.row.add(row).draw();
			}
		});
	</script>
</body>
</html>